<template functional>
  <div
    :ref="data.ref"
    :class="[data.class, data.staticClass]"
    :style="[data.style, data.staticStyle]"
    v-bind="data.attrs"
    v-on="listeners"
  >
    <button
      type="submit"
      class="w-full py-4 px-4 text-white font-medium tracking-wide uppercase focus:outline-none focus:shadow-outline"
      :class="[
        props.status === 'idle' ? props.color.idle : '',
        props.status === 'pending' ? props.color.pending : '',
        { 'bg-green-success': props.status === 'success' },
        { 'bg-red-error': props.status === 'error' },
        { 'opacity-75 cursor-default': props.status !== 'idle' },
      ]"
      :disabled="props.status !== 'idle'"
    >
      <span v-if="props.status === 'idle'">{{ props.label.idle }}</span>
      <span v-else-if="props.status === 'success'">
        {{ props.label.success }}
      </span>
      <span v-else-if="props.status === 'error'">{{ props.label.error }}</span>
      <span
        v-else
        class="mx-auto spinner fx-spin-circle"
        :style="{
          '--fx-spin-circle-color': props.spinner.bgColor,
          '--fx-spin-circle-top-color': props.spinner.fgColor,
        }"
      />
    </button>
  </div>
</template>

<script>
export default {
  name: 'ASubmitButton',
  props: {
    status: { type: String, default: 'idle' },
    label: {
      type: Object,
      default: () => ({
        idle: 'Enviar',
        success: 'Enviat',
        error: 'Error',
      }),
    },
    color: {
      type: Object,
      default: () => ({
        idle: 'bg-gray-500 hover:bg-gray-600',
        pending: 'bg-gray-500',
      }),
    },
    spinner: {
      type: Object,
      default: () => ({ bgColor: undefined, fgColor: undefined }),
    },
  },
};
</script>
